//Temperature_Controller_with_DS18B20
//******************************************************************************
//*  NOTE:                                                                     *
//*  Plase read me                                                             *
//* 1) DS18B20 can measure temperatures from -10C (-14F) to +85C (185F)        *
//*    if you want more information, you should browse through the datasheet.  *
//* 2) temp1 can`t take negative values , when the value is less than 0 then   *
//*    temp1=255 , however we can work with negative values through the        *
//*    auxilliary variables 'a' and 'b' that they indicate us when we are      *
//*    using that mode.                                                        *
//******************************************************************************
//LCD module connections -----------------------------------------------------//
sbit LCD_RS at RB4_bit;
sbit LCD_EN at RB5_bit;
sbit LCD_D4 at RB0_bit;
sbit LCD_D5 at RB1_bit;
sbit LCD_D6 at RB2_bit;
sbit LCD_D7 at RB3_bit;
sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;
//End LCD module connections--------------------------------------------------//

//global variables
const unsigned short TEMP_RESOLUTION = 12; //resolution
char *text = "000";
unsigned temp;
char temp1 = 0, e0=1, e1=1, e2=1,  temp2;
short int a=0 , b=0;

void Display_Temperature(unsigned int temp2write) {

  const unsigned short RES_SHIFT = TEMP_RESOLUTION - 8;

  if (temp2write & 0x8000) {  //check if temperature is negative.
      Lcd_Chr(2,7,'-');
      temp2write = ~temp2write + 1;
      a=1;       // if the temperature is negative.
  }
  else Lcd_Chr(2,7,' '), a=0; // if the temperature is positive.
 // convert temp2 to characters
  temp2 = temp2write >> RES_SHIFT ;
  if (temp2/100)  text[0] = temp2/100  + 48;
  else text[0] = ' ';
  text[1] = (temp2/10)%10 + 48;
  text[2] =  temp2 %10    + 48;
  Lcd_Out(2, 7, text);
}
void print_temp1() {

  // Write result in ASCII format
    unsigned char ch ;
    ch = temp1 / 10 ;
    Lcd_Chr(1,8,48+ch);
    ch = temp1 % 10;
    Lcd_Chr_CP(48+ch);
}
void set_up() {    // configuration for pic16f887

  ANSEL = 0;            // set the rest of pins as digital inputs or outputs.
  ANSELH = 0;
  TRISE0_bit=0;            // RE0 is configured as digital output.
  TRISD = 0x80;            // RD7 is configured as digital input.
  TRISB6_bit=1;            // RB6 and RB7 are configured as digital input.
  TRISB7_bit=1;
  RE0_bit = 0;
  PORTD = 0;               // clear PORTD
  C1ON_bit = 0;            // analog comparators off.
  C2ON_bit = 0;
  Lcd_Init();
  Lcd_Cmd(_LCD_CLEAR);
  Lcd_Cmd(_LCD_CURSOR_OFF);
 }
void message () {
  Lcd_Out(1, 1, "Temperature");
  Lcd_Out(2, 1, "Controller");
  delay_ms(2000);
  Lcd_Out(1, 1, "Rank_temperature");
  Lcd_Out(2, 1, ":-10_to_85 C");
  Lcd_Chr(2,11,223);
  delay_ms(3000);
  Lcd_Cmd(_LCD_CLEAR);
  Lcd_Out(1, 1, "Temp1: ");
  Lcd_Out(2, 1, "Temp2: ");
  Lcd_Chr(1,11,223);
  Lcd_Chr(2,11,223);     // Print degree character, 'C' for Centigrades.
  Lcd_Chr(1,12,'C');
  Lcd_Chr(2,12,'C');
}
void main() {
  set_up();
  message ();
  do {
    Ow_Reset(&PORTE, 2);       // Onewire reset signal.
    Ow_Write(&PORTE, 2, 0xCC); // Issue command SKIP_ROM.
    Ow_Write(&PORTE, 2, 0x44); //  Issue command CONVERT_T.
    Delay_us(120);
    Ow_Reset(&PORTE, 2);
    Ow_Write(&PORTE, 2, 0xCC); // Issue command SKIP_ROM.
    Ow_Write(&PORTE, 2, 0xBE); // Issue command READ_SCRATCHPAD.
    temp = Ow_Read(&PORTE, 2);
    temp = (Ow_Read(&PORTE, 2) << 8) + temp;
    Display_Temperature(temp);  // call the function to show temp2.
    
/////////////////////////////////Comparation////////////////////////////////////
   if((a==0) && (b==0)) {
   if(temp2 == temp1) PORTD = 2;
   if(temp2 >  temp1) PORTD = 1;
   if(temp2 <  temp1) PORTD = 4;
  }
   if((a==0) && (b==1)) {
   if((temp2 > 0)  &&  (temp1 > 0))   PORTD = 1;
   if((temp2 == 0) &&  (temp1 == 0))  PORTD = 2;
   if((temp2 == 0)  &&  (temp1 > 0)) PORTD = 1;
   }
   if((a==1) && (b==0)) {
   if((temp2 > 0) && (temp1 > 0))PORTD = 4;
   if((temp2 == 0) && (temp1 == 0))PORTD = 2;
   if((temp2 > 0) && (temp1 == 0))PORTD = 4;
  }
   if((a==1) && (b==1)) {
   if(temp2 == temp1) PORTD = 2;
   if(temp2 >  temp1) PORTD = 4;
   if(temp2 <  temp1) PORTD = 1;
  }
    if (b==0) {      // if we want to work with positive values.
    Lcd_Chr(1,7,' ');
    print_temp1();
    RE0_bit = 0;
   }
    if (b==1) {      // if we want to work with negative values.
    if(temp1 == 0) Lcd_Chr(1,7,' ');
    if(temp1 > 0)  Lcd_Chr(1,7,'-');
    if(temp1>10)   temp1=10;
    print_temp1();
    RE0_bit = 1;
   }

////////////////////////////////////////////////////////////////////////////////

   if (Button(&PORTB,7,5,0)) e0=0;      //if the button has been pushed
   if (e0==0 && Button(&PORTB,7,5,1)){  //and after that the button is free
       temp1++;                         //increase temp1.
   if (temp1>85) temp1=0;
       e0=1;
   }
   if  (Button(&PORTB,6,5,0)) e2=0;     //if the button has been pushed
   if (e2==0 && Button(&PORTB,6,5,1)){  //and after that the button is free
       temp1--;                       //decrease temp1.
   if (temp1==255) temp1=85;  // temp=-1 >>> temp1=255 >>>> temp1=125.
       e2=1;
   }
   if (Button(&PORTD,7,5,0)) e1=0;    //if the button has been pushed
   if (e1==0 && Button(&PORTD,7,5,1)){  //and after that the button is free
       b++;                          //increase b.
   if (b>1) b=0;              //  variable for Negative values.
       e1=1;
   }

   if (Button(&PORTB,6,300,0) && Button(&PORTB,7,300,0)){  //fast mode.
       temp1++;
   if(temp1>85) temp1=0;
   }
   Delay_ms(100);
  } while (1);
}// END.